package ch.epfl.ppo;

import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.NoSuchElementException;

public class Lists {
    public static <T> void addMultipleOccurrences(List<T> list, T elem, int n) {
        for (int i = 0; i < n; ++i)
            list.add(elem);
    }

    public static <T> void copy(List<T> from, List<T> to) {
        for (T elem: from)
            to.add(elem);
    }
    
    public static <T> T max(List<T> list, Comparator<T> comp) {
        if (list.isEmpty())
            throw new NoSuchElementException("empty list");
        Iterator<T> it = list.iterator();
        T max = it.next();
        while (it.hasNext()) {
            T next = it.next();
            if (comp.compare(next, max) > 0)
                max = next;
        }
        return max;
    }
}
